#include <iostream>
using namespace std;
int mas[100000];
int old[100000];
bool nab[100000];
int main ()
{
    long N;
    cin>>N;
    short vruska[N-1][2];
    for (long i=0; i<N-1; i++)
    {
        cin>>vruska[i][0]>>vruska[i][1];
        mas[vruska[i][0]]++;
    }
    for (long o=0; o<N-1; o++)
    {
        for (long z=0; z<N-1; z++)
        {
            for (long i=0; i<N-1; i++)
            {
                if(mas[vruska[i][0]]!=old[vruska[i][0]])
                {
                    mas[vruska[i][0]]=mas[vruska[i][0]]+mas[vruska[i][1]];
                    old[vruska[i][0]]=mas[vruska[i][0]];
                }
            }
        }
    }
    long Q;
    cin>>Q;
    short vaprosi[Q];
    for (int i=0; i<Q; i++) cin>>vaprosi[i];
    for (int i=0; i<Q; i++) cout<<mas[vaprosi[i]]<<endl;
    return 0;
}
